/***************************************************************
 * Name:      LED_BLINK_02Main.cpp
 * Purpose:   Code for Application Frame
 * Author:    Niels Nikolaisen (niko@nikolaisens.de)
 * Created:   2016-01-27
 * Copyright: Niels Nikolaisen (www.elektronik.nmp24.de)
 * License:
 **************************************************************/

#include "LED_BLINK_02Main.h"
#include <wx/msgdlg.h>
#include <wiringPi.h>

//(*InternalHeaders(LED_BLINK_02Dialog)
#include <wx/settings.h>
#include <wx/font.h>
#include <wx/intl.h>
#include <wx/string.h>
//*)

//helper functions
enum wxbuildinfoformat {
    short_f, long_f };

wxString wxbuildinfo(wxbuildinfoformat format)
{
    wxString wxbuild(wxVERSION_STRING);

    if (format == long_f )
    {
#if defined(__WXMSW__)
        wxbuild << _T("-Windows");
#elif defined(__UNIX__)
        wxbuild << _T("-Linux");
#endif

#if wxUSE_UNICODE
        wxbuild << _T("-Unicode build");
#else
        wxbuild << _T("-ANSI build");
#endif // wxUSE_UNICODE
    }

    return wxbuild;
}

//(*IdInit(LED_BLINK_02Dialog)
const long LED_BLINK_02Dialog::ID_STATICTEXT1 = wxNewId();
const long LED_BLINK_02Dialog::ID_BUTTON1 = wxNewId();
const long LED_BLINK_02Dialog::ID_STATICLINE1 = wxNewId();
const long LED_BLINK_02Dialog::ID_BUTTON2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(LED_BLINK_02Dialog,wxDialog)
    //(*EventTable(LED_BLINK_02Dialog)
    //*)
END_EVENT_TABLE()

LED_BLINK_02Dialog::LED_BLINK_02Dialog(wxWindow* parent,wxWindowID id)
{
    //(*Initialize(LED_BLINK_02Dialog)
    Create(parent, id, _("wxWidgets app"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE, _T("id"));
    BoxSizer1 = new wxBoxSizer(wxHORIZONTAL);
    StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("LED Control"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
    wxFont StaticText1Font = wxSystemSettings::GetFont(wxSYS_DEFAULT_GUI_FONT);
    if ( !StaticText1Font.Ok() ) StaticText1Font = wxSystemSettings::GetFont(wxSYS_DEFAULT_GUI_FONT);
    StaticText1Font.SetPointSize(20);
    StaticText1->SetFont(StaticText1Font);
    BoxSizer1->Add(StaticText1, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 10);
    BoxSizer2 = new wxBoxSizer(wxVERTICAL);
    Button1 = new wxButton(this, ID_BUTTON1, _("LED ON"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
    BoxSizer2->Add(Button1, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 4);
    StaticLine1 = new wxStaticLine(this, ID_STATICLINE1, wxDefaultPosition, wxSize(10,-1), wxLI_HORIZONTAL, _T("ID_STATICLINE1"));
    BoxSizer2->Add(StaticLine1, 0, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 4);
    Button2 = new wxButton(this, ID_BUTTON2, _("LED OFF"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
    BoxSizer2->Add(Button2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 4);
    BoxSizer1->Add(BoxSizer2, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 4);
    SetSizer(BoxSizer1);
    BoxSizer1->Fit(this);
    BoxSizer1->SetSizeHints(this);

    Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&LED_BLINK_02Dialog::OnButton1Click);
    Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&LED_BLINK_02Dialog::OnButton2Click);
    //*)
    // GPIO initialisieren
    wiringPiSetup();
    pinMode(0, OUTPUT);

}

LED_BLINK_02Dialog::~LED_BLINK_02Dialog()
{
    //(*Destroy(LED_BLINK_02Dialog)
    //*)
}

void LED_BLINK_02Dialog::OnButton1Click(wxCommandEvent& event)
{
    digitalWrite(0, HIGH);
}

void LED_BLINK_02Dialog::OnButton2Click(wxCommandEvent& event)
{
    digitalWrite(0, LOW);
}
